//Delta Emmett
//Optional 2 part bracket for Bottom Vertex
//12/9/2015     By: David Bunch
Ht = 12;
HoleID = 4.5;           //I am using M4x25mm bolts to attach brackets to Vertex
BoltHdDia = 7.8;
Qty = 2;        //1, 2 or 4 quantity
module Bracket()
{
    linear_extrude(height = Ht, center = false , convexity = 10)
    import(file = "EMT_SideHoldingBracket_rev5.dxf", layer = "BotBracket");
}
module BracketExt()
{
    linear_extrude(height = Ht, center = false , convexity = 10)
    import(file = "EMT_SideHoldingBracket_rev5.dxf", layer = "BotBracketExtend");
}
module Bump()
{
    translate([0,0,-3])
    cylinder(d1=0,d2=6,h=3.01,$fn=6);
    cylinder(d=6,h=28,$fn=6);
    translate([0,0,27.99])
    cylinder(d1=6,d2=0,h=3,$fn=6);
}
module BracketCube()
{
    union()
    {
        difference()
        {
            translate([-7.5538,0,0])
            cube([59,4,Ht]);
            translate([0,-1,Ht/2])
            rotate([-90,0,0])
            cylinder(d=HoleID,h=30,$fn=24);
            translate([43,-1,Ht/2])
            rotate([-90,0,0])
            cylinder(d=HoleID,h=30,$fn=24);
        }
        translate([7.1,0,Ht/2])
        rotate([0,90,0])
        Bump();
    }
}
module DrawFinal()
{
    difference()
    {
        Bracket();
        translate([0,-1,Ht/2])
        rotate([-90,0,0])
        cylinder(d=HoleID,h=30,$fn=24);
//Cut for M4 Bolt Head
        translate([0,18.4,Ht/2])
        rotate([-90,0,0])
        cylinder(d=BoltHdDia,h=Ht,$fn=24);
    }
}
module DrawFinalExt()
    difference()
    {
        BracketExt();
        translate([0,-1,Ht/2])
        rotate([-90,0,0])
        cylinder(d=HoleID,h=30,$fn=24);
        translate([43,-1,Ht/2])
        rotate([-90,0,0])
        cylinder(d=HoleID,h=30,$fn=24);
//Cut for M5 Bolt Head
        translate([0,19,Ht/2])
        rotate([-90,0,0])
        cylinder(d=BoltHdDia,h=Ht,$fn=24);
    }
module DrawTwo()
{
    DrawOne();
    //translate([-35,-50,0])
    rotate([0,0,180])
    DrawOne();
}
module DrawOne()
{
    //DrawFinal();
    translate([2,-11.5,0])
    {
    translate([-6,0,0])
    translate([3,0,0])
    rotate([0,0,90])
    DrawFinalExt();
        translate([-4,-22,4])
        rotate([0,-90,0])
    //translate([-10,-22,0])
    rotate([0,0,90])
    BracketCube();
    }
}
//DrawFinal();
//translate([12,11,0])
//rotate([0,0,180])
//DrawFinal();
//DrawOne();
if (Qty == 1)
{
    DrawOne();
}
if (Qty > 1)
{
    DrawTwo();
}
if (Qty > 2)
{
    translate([80,-15,0])
    DrawTwo();
}
